#include "oi.h"
#include "Roomba.h"
#include "../xhardware.h"


// Transmit a byte over the serial port
void byteTx(unsigned char value)
{
  	uartSendByte(RoombaUart, value);
}



// Send Create drive commands in terms of velocity and radius
void drive(unsigned short velocity, unsigned short radius)
{
  byteTx(CmdDrive);
  byteTx(((velocity >> 8) & 0x00FF));
  byteTx((velocity & 0x00FF));
  byteTx(((radius >> 8) & 0x00FF));
  byteTx((radius & 0x00FF));

}

// Define songs to be played later
void defineSongs(void)
{
  // Reset song
  byteTx(CmdSong);
  byteTx(RESET_SONG);
  byteTx(4);
  byteTx(60);
  byteTx(6);
  byteTx(72);
  byteTx(6);
  byteTx(84);
  byteTx(6);
  byteTx(96);
  byteTx(6);

  // Start song
  byteTx(CmdSong);
  byteTx(START_SONG);
  byteTx(6);
  byteTx(69);
  byteTx(18);
  byteTx(72);
  byteTx(12);
  byteTx(74);
  byteTx(12);
  byteTx(72);
  byteTx(12);
  byteTx(69);
  byteTx(12);
  byteTx(77);
  byteTx(24);

  // Bump song
  byteTx(CmdSong);
  byteTx(BUMP_SONG);
  byteTx(2);
  byteTx(74);
  byteTx(12);
  byteTx(59);
  byteTx(24);

  // End song
  byteTx(CmdSong);
  byteTx(END_SONG);
  byteTx(5);
  byteTx(77);
  byteTx(18);
  byteTx(74);
  byteTx(12);
  byteTx(72);
  byteTx(12);
  byteTx(69);
  byteTx(12);
  byteTx(65);
  byteTx(24);
}

void startCreate(void)
{
byteTx(CmdStart);
defineSongs();
byteTx(CmdControl);
byteTx(CmdFull);
// Stop just as a precaution
drive(0, RadStraight);

  // Play the reset song and wait while it plays
byteTx(CmdPlay);
byteTx(RESET_SONG);
//add delay here for song
}

void RoombaReadSensors(void)
{
	sensors_index = 0;	
	byteTx(CmdSensors);			//request sensor packets from Create
    byteTx(6);		
    while (sensors_index < Sen6Size)
	{
		while (!uartReceiveBufferIsEmpty(RoombaUart))                      
			sensors[sensors_index++] = uartGetByte(RoombaUart);
	}
	
		roomba_distance += (int)((sensors[SenDist1] << 8) | sensors[SenDist0]);
		angle += (int)((sensors[SenAng1] << 8) | sensors[SenAng0]);  
		

}

void playSong(int song)
{
	byteTx(CmdPlay);
    byteTx(song);
}

