/*
		This file has been auto-generate by WebbotLib tools V1.1
				** DO NOT MODIFY BY HAND **
*/
#ifndef _HARDWARE_H_
#define _HARDWARE_H_
#include "xhardware.h"
// Type of interrupt handler to use for uart interrupts.
// Do not change unless you know what you're doing.
#ifndef UART_INTERRUPT_HANDLER
#define UART_INTERRUPT_HANDLER	ISR
#endif

// ------------------- uart1 -------------------

// Create hardware UART uart1
HW_UART _uart1 = MAKE_UART_BUFFERED(null,null,UCSR1A,UCSR1B,UBRR1L,UBRR1H,UDR1,null,BV(U2X1),D2,D3,&uart1GetByte,&uart1SendByte);

// Create a routine to write bytes to uart1
// You can set rprintf to use it by calling rprintfInit(&uart1SendByte)
MAKE_WRITER(uart1SendByte){
	return uartSendByte(uart1,byte);
}

// Create a routine to read a byte from uart1
// Returns -1 if there was no data
MAKE_READER( uart1GetByte){
	return uartGetByte(uart1);
}

#ifndef USART1_TX_vect
# error Uart1 Tx complete vector undefined
#else
UART_INTERRUPT_HANDLER(USART1_TX_vect){
	uartTransmitService(uart1);
}
#endif

#ifndef USART1_RX_vect
# error Uart1 Rx complete vector undefined
#else
UART_INTERRUPT_HANDLER(USART1_RX_vect){
	uartReceiveService(uart1);
}
#endif

// ------------------- Uart2 -------------------
// Make a transmit buffer for Uart2
static unsigned char tx_Uart2_Buf[10];
static cBuffer tx_Uart2_Buffer = MAKE_BUFFER(tx_Uart2_Buf);

// Make a receive buffer for Uart2
static unsigned char rx_Uart2_Buf[80];
static cBuffer rx_Uart2_Buffer = MAKE_BUFFER(rx_Uart2_Buf);


// Create hardware UART Uart2
HW_UART _Uart2 = MAKE_UART_BUFFERED(&rx_Uart2_Buffer,&tx_Uart2_Buffer,UCSR2A,UCSR2B,UBRR2L,UBRR2H,UDR2,null,BV(U2X2),H0,H1,&Uart2GetByte,&Uart2SendByte);

// Create a routine to write bytes to Uart2
// You can set rprintf to use it by calling rprintfInit(&Uart2SendByte)
MAKE_WRITER(Uart2SendByte){
	return uartSendByte(Uart2,byte);
}

// Create a routine to read a byte from Uart2
// Returns -1 if there was no data
MAKE_READER( Uart2GetByte){
	return uartGetByte(Uart2);
}

#ifndef USART2_TX_vect
# error Uart2 Tx complete vector undefined
#else
UART_INTERRUPT_HANDLER(USART2_TX_vect){
	uartTransmitService(Uart2);
}
#endif

#ifndef USART2_RX_vect
# error Uart2 Rx complete vector undefined
#else
UART_INTERRUPT_HANDLER(USART2_RX_vect){
	uartReceiveService(Uart2);
}
#endif

// ----------- Define the ADC channels ----------
const uint8_t NUM_ADC_CHANNELS = 16;

// ----------- My devices -----------------------
SWITCH button = MAKE_SWITCH(D5);
SEGLED led_display = MAKE_SEGLED(C3,C2,C0,D6,D7,C4,C5,null,false);
static SEGLED_LIST marquee_list[] = {&led_display};
MARQUEE marquee = MAKE_MARQUEE(marquee_list,500000,2000000,&marquee_put_char);
// Create a Writer to write to marquee
MAKE_WRITER(marquee_put_char){
	return marqueeSendByte(&marquee,byte);
}
Sharp_GP2D12 distance = MAKE_Sharp_GP2D12(ADC0);
SERVO scan_servo = MAKE_SERVO(true,B6,1400,900);
static SERVO_LIST bank1_list[] = {&scan_servo};
SERVO_DRIVER bank1 = MAKE_SERVO_DRIVER(bank1_list);

// ----------- Initialise built in devices ------
void sysInitHardware(void){
	SWITCH_init(&button);
	setErrorLog(&uart1SendByte);
	rprintfInit(&uart1SendByte);
	uartInit(uart1,115200);
	segled_init(&led_display);
}

// ----------- Initialise my added devices ------
void initHardware(void){
	distanceInit(distance);
	uartInit(Uart2,57600);
	servoPWMInit(&bank1);
}
// ----------- Register the statusLED -----------
void registerLED(void){
	statusLEDregister(C1,false);
}

// ----------- Ports are configured on the fly --
void configure_ports(void){
}

#endif
